<?php

namespace Drupal\onehub;

use Drupal\onehub\OneHub;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Drupal\Core\Url;

/**
 * Class OneHub.
 *
 * @package Drupal\onehub
 */
class OneHubOauth extends OneHub {

  /**
   * Gets the Authorization Code token via user interaction on a redirect.
   */
  public function getAuthCode() {
    // Auth Url
    $this->setURL($this->base_url . '/oauth/authorize');

    // Set the auth query params.
    $query = array(
      'query' => array(
        'client_id' => \Drupal::config('onehub.settings')->get('onehub_application_id'),
        'response_type' => 'code',
        'redirect_uri' => $this->redirect_uri,
      ),
    );

    // The Url used for auth.
    $url = Url::fromUri(parent::getURL(), $query)->toString();

    // Go to the url and return to the redirect URI.
    $response = new RedirectResponse($url);
    $response->send();
  }

  /**
   * @inheritdoc
   */
  public function getAccessCode($code) {
    parent::getAccessCode($code);
  }

}
